//Nelinearni rovnice P(x)=0, kde P(x) je polynom
//Newtonovou metodou teen

#include <iostream>
#include <stdlib.h>
using namespace std;

double abs(double a)
{
	if (a<0) return -a; else return a;
}
double horner(double koef[], double k[], int n, double a)
{
	// Hornerovo schema pro urceni hodnoty polynomu P(x) pro x=a
    // a pro hodnotu prvn derivace P' (x) a 
    // druh derivace P''(x) pro x=a
	// n stupen polynomu P(x) - max.20, koef[] koeficienty polynomu
	double h[20];
	int i,j;
	for(j=0;j<=n;j++)
		k[j]=koef[j];
	for(j=n;j>0;j--)
	{
		for(i=1;i<=j;i++)
		{
			h[i]=a*k[i-1];
			k[i]=k[i]+h[i];
		}
	}
		return k[n];
		// k[n]=P(a); k[n-1]=P'(a); k[n-2]=(1/2)*P''(a);
		// ... k[0]=(1/n!)Pn(a)
}

int main()
{
	double a,b; // meze intervalu, ve kterem hledame reseni
	double c,d; // hodnoty P(a), P(b)
	double eps; // akceptovatelna chyba
	double koef[20], k[20]; // koeficienty polynomu
	double P1c,P1d,P2c,P2d; //prvni a druhe derivace v bodech a,b
	double s,s0;
	int i,n;
cti:cout << "Zadejte stupen polynomu:\n";
	cin >> n;
	if (n>20)
	{ cout << "Stupen musi byt max.20!\n"; goto cti; }
	cout << "Zadejte koeficienty polynomu\n";
	for(i=0;i<=n;i++)
		cin >> koef[i];
cint:	cout << "Zadejte zacatek intervalu: ";
	cin >> a;
	cout << "\nZadejte konec intervalu: ";
	cin >> b;
	c=horner(koef,k,n,a); cout << "c=" << c << endl;
	P1c=k[n-1]; P2c=2*k[n-2];
	d=horner(koef,k,n,b); cout << "d=" << d << endl;
	P1d=k[n-1]; P2d=2*k[n-2];
	if(c==0) 
    {
       cout << "\nReseni je:" << a; 
       system("PAUSE"); return 0;
    }
	if(d==0) {cout << "\nReseni je:" << b; return 0;}
	if((c*d)>0) 
    {
       cout << "\nV danem intervalu nemusi existovat reseni\n"; 
       goto cint; 
    }
	if(c*P2c>0) {s0=a;s=s0-c/P1c;}
	else        {s0=b;s=s0-d/P1d;}
	cout << "\nZadejte pripustnou chybu: ";
	cin >> eps;
	cout <<"\n";
	while (abs(s-s0) > eps)
	{
		s0 = s; c=horner(koef,k,n,s);
		s=s0-(c/k[n-1]);
	} // konec while
	cout << "\nResenim je: " << s << "  "; system("PAUSE"); return 0;
}

