/* linsez3.c */
/* vytvo linern seznam s neusporadanymi hodnotami prvku */ 
/* z pole a pak pouzije funkci mergeSort k setrideni tohoto */
/* linearniho seznamu */ 
#include <stdlib.h>
#include <stdio.h>

struct record
{
	struct record *next;
	int prvek;
};
int n;
typedef struct record zaznam;
zaznam *p, *q, *setr;

zaznam * merge(zaznam *a, zaznam *b)
/* funkce merge sdruzuje dva linearni seznamy do jednoho.  */
/* Vraci ukazatel na sdruzeny seznam.                      */                                      
/* Funkce je vyvolavana z funkce mergeSort.                */                   
{
	zaznam zacatek;
	zaznam *c = &zacatek; 
	
	do
	{
		if(a->prvek <= b->prvek)
		{
			c->next = a;
			c = a;
			a = a->next;
		}
		else
		{
			c->next = b;
			c = b;
			b = b->next;
		}
	}while ((a != NULL) && (b != NULL));
	c->next = (a == NULL) ? b : a;

	return zacatek.next;
}

zaznam* mergeSort(zaznam * c)
/* Funkce rozdeluje seznam, na ktery ukazuje ukazatel c, na 2 */
/* casti, ktere jsou pak sdruzovany funkci merge do jednoho.  */ 
{
	zaznam *a, *b;

	if (c->next == NULL)
		return c;
	a = c;
	b = c->next; 
	b = b->next;
	while (b != NULL)        /* v cyklu se posouva ukazatel b 2x */
	{                        /* rychleji nez ukazatel c, ktery   */
		c = c->next;         /* tedy na konci cyklu ukazuje do   */
		b = b->next;         /* poloviny seznamu, zatimco b na   */
		if(b == NULL)        /* jeho konec.                      */
			break;
		b = b->next;
	}
	b = c->next;             /* ted ukazuje b do poloviny,       */
	c->next = NULL;          /* a na zacatek seznamu.            */
	return merge(mergeSort(a), mergeSort(b));
}
int Create(int n);
void pruchod(zaznam * p);
void release(zaznam * p);
int Create(int n) /* vytvori linearni seznam */
{
	/* p ukazuje na zacatek seznamu */
		q=(zaznam*) malloc(sizeof(zaznam));
		if (q!=NULL)
		{
			/* printf("%d",n); */
			q->prvek = n;
			q->next = p;
			p = q;
		}
		else return 1;
	return 0;
}
void pruchod(zaznam *p) /* vytiskne hodnoty uloen v lin.seznamu */
{
    printf("hodnoty v seznamu:\n"); 
	while (p!=NULL)
	{
		printf("%d\n", p->prvek);
		p = p->next;
	}
	system("PAUSE");
}
void release(zaznam *p) /* uvoln pidlenou pam */
{
	while(p!=NULL)
	{
		q = p->next;
		free (p); 
		p=q;
	}
}
int main()
{
	int a[10]={8,3,7,5,4,2,9,1,6,10};
	int i;
	p=NULL;
	for (i=0;i<10;i++)
	{
		n = a[i];
		if (Create(n) == 1)
		{
			printf("Nedostatek pameti\n");
			return 1;
		}
	}
	pruchod(q);
	setr = mergeSort(q);
	pruchod(setr);
	release(setr);
	return 0;
}
