/* hran_nasled.c */
/* seznam hran prevede na seznam nasledniku                          */
/* Neorientovany graf prevede na orientovany doplnenim hran          */
/* s opacnou orientaci.                                              */
/* Uzly mohou byt poradove ocislovany od 0 nebo 1                    */ 
/* pole u a e pouzivam od indexu shodneho s pocatecnim cislem uzlu   */ 
#include <stdlib.h>
#include <stdio.h>
#define UZLU 200
#define HRAN 500
int main()
{
	int i,j,k,x,y;
	int v[HRAN];   /* vstupni uzel hrany  */
	int w[HRAN];   /* vystupni uzel hrany */ 
	int u[UZLU+2]; /* v poli indexuji od poc. c. uzlu   */
	int e[HRAN+1]; /* indexuji od poc. c. uzlu          */
	/* u a e tvori seznam nasledniku, v a w seznam hran */
	int uzlu,hran; /* skutecny pocet uzlu a hran        */
	int neorient;  /* 1 neorientovany, 0 orient. graf   */
	int uzlyod;    /* cislovani uzlu od 1 nebo 0        */
	FILE *fu;
	FILE *fe;
	char *jmeno1="nasled_u.txt";
	char *jmeno2="nasled_e.txt";
	if ((fu=fopen(jmeno1,"wt"))==NULL)
	{
		printf("Soubor nemohu otevrit\n");
		system("PAUSE"); return 1;
	}
	if ((fe=fopen(jmeno2,"wt"))==NULL)
	{
		printf("Soubor nemohu otevrit\n");
		system("PAUSE"); return 1;
    }  
	printf ("Zadejte pocet uzlu:\n");
	scanf ("%d",&uzlu);
	printf("zadejte, odkud cisluji uzly (0 nebo 1)\n");
	scanf("%d",&uzlyod);
	printf ("Zadejte pocet hran:\n");
	scanf ("%d",&hran);
	printf ("Zadejte typ grafu: 1 neorientovany, 0 orient.\n");
	scanf ("%d",&neorient);
	printf("Zadejte vstupni a vyst.uzel jednotlivych hran:\n");
	for (j=0;j<hran;j++)
		scanf("%d%d",&v[j],&w[j]);
	/* kontrola zadanych udaju */
	i=0;
	for (j=0;j<hran;j++)
		if ((v[j]>uzlu-1+uzlyod) || (w[j]>uzlu-1+uzlyod) || 
           (v[j]<uzlyod) || (w[j]<uzlyod)) i=1; 
	if ((uzlu > UZLU) || (hran > HRAN)) i=1;
	if (i) 
	{  
	  printf ("c.uzlu > pocet uzlu nebo mnoho uzlu ci hran\n");
	  system("PAUSE");
	  return 1;
	}
	/* hrany s opacnou orientaci pro neorientovany graf */
	if (neorient==1)
	{                
	   for (i=0; i<hran; i++)
	   {
           v[i+hran]=w[i];
           w[i+hran]=v[i];
       }
       hran+=hran;
    }
	/* setrideni seznamu hran podle vst.uzlu */						
	for (i=0; i<hran-1; i++)
	{
		k=i; x=v[i]; y=w[i];
		for (j=i+1; j<hran; j++)
			if (v[j]<x)
			{
				k=j; x =v[j]; y=w[j];
			}
			v[k]=v[i]; v[i]=x; w[k]=w[i]; w[i]=y; 
	}                          
	/* vlastni algoritmus */
	k=uzlyod; i=uzlyod; /* k je cislo uzlu, i index v e */
	for (j=uzlyod;j<uzlu+1+uzlyod;j++) u[j]=0;
	u[k]=i; 
	for (j=0;j<hran;j++)
	{
		if (v[j]==k)
		{
            e[i]=w[j]; i++;
        }
        else
        {
            k=v[j]; u[k]=i; 
            e[i]=w[j]; i++; 
        }
	}
	for (j=k+1;j<uzlu+2;j++)
	u[j]=i; 
	for (j=1;j<uzlu+2;j++)
	   if (u[j]==0) u[j]=u[j+1]; 
	/* zobrazeni vysledku */
	printf ("Seznam hran:\n");
	for (j=0; j<hran; j++)
		printf("%2d ",v[j]);
	printf("\n");
	for (j=0; j<hran; j++)
		printf("%2d ",w[j]);
	printf("\n");
	printf ("Vysledny seznam nasledniku:\n"); 
	for (j=uzlyod; j<uzlu+1+uzlyod; j++)
	{
		printf("%2d ",u[j]);
		fprintf(fu,"%2d ",u[j]);
    }
    fprintf(fu,"%2d ",-1);
	printf("\n");
	for (j=uzlyod; j<hran+uzlyod; j++)
	{
		printf("%2d ",e[j]);
		fprintf(fe,"%2d ",e[j]);
    }
    fprintf(fe,"%2d ",-1
    );
	printf("\n"); 
	if (fclose(fu)==EOF)
    {
       printf("Soubor %s nemohu zavrit\n",jmeno1);
       system("PAUSE"); return 1;
    }
    if (fclose(fe)==EOF)
    {
       printf("Soubor %s nemohu zavrit\n",jmeno2);
       system("PAUSE"); return 1;
    }
    system("PAUSE");
	return 0;
}
 
										
	
