/* BinTree1.c */
/* vytvori binarni vyhledavaci strom      */
/* rekurzivni funkce hledej pro vyhledani */
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#define KOLIK 50
struct uzel
{
  struct uzel *levy, *pravy;  /* ukazatele na levy a pravy podstrom */
  int klic;
  int pocet;
  int level;
}uzel;
struct uzel *p;                /* ukazatel na koren stromu */
struct uzel *q,*u,*v;
int x;
int jeste;
int uloz()         /* funkce pro ulozeni zaznamu do stromu */
{
  q=(struct uzel *)malloc(sizeof(struct uzel));
  if (q==NULL) return 1;
  q->levy=NULL; q->pravy=NULL;
  q->klic = x; q->pocet = 1; jeste=0;			
  return 0;
}
 
int BinTree(int x)           
/* funkce pro vytvoen binrnho vyhledvacho stromu */
{
  jeste=1;
  if (p==NULL)
  {
    if (uloz()==1) return 1;
    p=q; 
    p->level=0; 
  }
  else
  u=p;
  while(jeste)
  {
    if(u->klic==x)
    {
    	u->pocet = u->pocet + 1; jeste=0;
    }
    else
    {
      if (u->klic>x)
      {
	    if (u->levy != NULL) u=u->levy; 
    	else
    	{
	      if (uloz()==1) return 1;
	      q->level = u->level + 1;
	      u->levy = q;
    	}
      }
      else /* u->klic < x */
      {
    	if(u->pravy!=NULL) u=u->pravy; 
    	else
    	{
          if (uloz()==1) return 1;       
	      q->level = u->level + 1;
	      u->pravy = q;
    	}
      }
    }
  }
  return 0;
}
struct uzel * hledej(struct uzel * p, int x)
{
    static struct uzel * y=NULL;
    if (x==p->klic) y=p;
    if (x < p->klic)
          if (p->levy!=NULL) hledej(p->levy,x);
    if (x > p->klic)      
          if (p->pravy!=NULL) hledej(p->pravy,x);
    return y;
}
void Tisk(struct uzel * p)                    
/* zobrazeni ulozenych zaznamu  pruchod do hloubky */ 
{
  printf("%4d %4d %4d\n",p->klic,p->pocet,p->level);      
  /* preorder */
  if (p->levy!=NULL)
  Tisk(p->levy);
  /* printf("%4d %4d %4d\n",p->klic,p->pocet,p->level); */
  /* inorder */
  if (p->pravy!=NULL)
  Tisk(p->pravy);
  /* printf("%4d %4d %4d\n",p->klic,p->pocet,p->level); */
  /* postorder */
}
void Zrus(struct uzel *p)       /* postupne ruseni stromu */
{
  if (p->levy != NULL)
    Zrus(p->levy);
  if (p->pravy != NULL)
    Zrus(p->pravy);
  free (p);
}
int main()              /* hlavn program pro oven vech funkc */
{
  p=NULL;
  int i;
  int pole[11] = {5,11,2,2,4,9,1,12,8,3,10};
  for (i=0; i<11; i++)
  {
    x = pole[i];
    if (BinTree(x) == 1)
    {
      printf("Nedostatek pameti\n");
      return 1;
    }
  }
  /* inicializace genertoru nhodnch sel */
  /* srand((unsigned int)time(NULL));  
  for(i=1;i<KOLIK;i++)
  {
    x=rand()%KOLIK +1;                   
    if (BinTree(x) == 1)
    {
      printf("Neni pamet\n");
      return 1;
    }
  } */
  printf("Binarni strom - pruchod do hloubky\n");
  printf("klic pocet uroven\n");     
  Tisk(p); 
  printf ("zadejte hodnotu klice pro hledani\n");
  scanf("%d",&x);
  v=hledej(p,x);
  if (v==NULL) printf ("nenaslo se\n");
  else
  printf("naslo se %d %d %d\n",v->klic,v->pocet,v->level);
  system("PAUSE");
  Zrus(p);
  return 0;
}

