/* BinTree2 - vytvori binarni strom                     */
/* Tisk - zobrazi data stromu pruchodem do hloubky      */
/* Tisk2 - zobrazi data stromu pruchodem do sirky       */
/* Vynech - vynecha vrchol s daty s pozadovanym klicem  */
/* zrus - zrusi binarni strom a uvolni pamet            */
/* prace s frontou se odehrava ve funkci Tisk2          */
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <time.h>
#define KOLIK 50
struct uzel
{
  struct uzel *levy, *pravy;
  int klic;
  int pocet;
  int level;
};
struct uzel *p; /* koren stromu */
struct uzel *q,*u;
int x;
int jeste;

/* pridani hodnoty do binarniho stromu a vyhledavani ve stromu */
int uloz()
{
  q=(struct uzel*)malloc(sizeof(struct uzel));
  if (q==NULL) return 1;
  q->levy=NULL; q->pravy=NULL;
  q->klic = x; q->pocet = 1; jeste=0;			
  return 0;
} 
int BinTree(int x)
{
  jeste=1;
  if (p==NULL)
  {
    if (uloz()==1) return 1;
    p=q; 
    p->level=0; 
  }
  else
  u=p;
  while(jeste)
  {
    if(u->klic==x)
    {
         u->pocet = u->pocet + 1; jeste=0;
    }
    else
    {
      if (u->klic>x)
      {
        if (u->levy != NULL) u=u->levy;  
        else
        {
          if (uloz()==1) return 1;
          q->level = u->level + 1;
          u->levy = q;
        }
      }
      else /* u->prvek < x */
      {
        if(u->pravy!=NULL) u=u->pravy; 
        else
        {
          if (uloz()==1) return 1;       
          q->level = u->level + 1;
          u->pravy = q;
        }
      }
    }
  }
  return 0;
}

int Vynech(int x)
{
  struct uzel *q,*u,*w;
  if (p==NULL)
  {
    printf("Strom je przdn");
    return 1;
  }
  u=p; q=p; w=p;
  jeste=1;
  while(jeste)
  {
    if(u->klic==x)
    {
      jeste=0;
      printf("Vynechat %d\n",x);
      q = u;	                 /* q ukazuje na vypousteny zaznam  */
      if ((u->levy==NULL) && (u->pravy==NULL)) 
      /* uzel nema naslednika  */
      {
      	if (w!=u)                /* w je predchudcem u nebo rovno u */
      	{
	        if (w->levy==u)
            w->levy=NULL;
        	else
	          w->pravy=NULL;
        }  
        free(u); return 0;
      }
      if ((u->levy!=NULL) && (u->pravy!=NULL)) 
      /* uzel ma oba nasledniky */
      {
        w=u; u=u->levy;		  /* hledam v levem podstromu*/
        while (u->pravy!=NULL)                
        {
      	  w=u; u=u->pravy;
        }  
        /* u ukazuje na kandidata pro vymenu dat s vypoustenym uzlem */
        q->klic = u->klic; q->pocet = u->pocet; /* vymena dat        */
        if (u->levy==NULL)           /* naslednik muze byt jen vlevo */
        {		                     /* uzel nema naslednika         */
          if (w->pravy==u)
            w->pravy=NULL;
	        else
            w->levy = NULL;
	        free(u); return 0;
        }
        else            	           /* ma jednoho naslednika   */
        {
	        if (w->pravy == u)
	          w->pravy=u->levy;
	       else
	          w->levy=u->levy;
	        free(u); return 0;
        }
      }
      else			            /* ma jednoho naslednika   */
      {
        if(u->levy==NULL)					  
        {									  
	        if (w->pravy==u)
      	  {
	          w->pravy=u->pravy; free(u); return 0;
	        }
	        else
	        {
	          w->levy=u->pravy; free(u); return 0;
	        }
        }
        else								  
        {
          if(w->pravy==u)
            w->pravy=u->levy;
          else
            w->levy=u->levy;
          free(u); return 0;
        }
      }
    }
    else
    {
      if (u->klic>x)
      {
        if (u->levy != NULL)
        {
          w = u; u=u->levy;  
        }
        else
        {
        printf("Klic %d neni ve stromu\n");
        return 1;
        }                
      }
      else                                        /* u->klic < x */
      {
        if(u->pravy!=NULL)
        {
        w = u; u=u->pravy; 
        }
        else
        {
          printf("Klic %d neni ve stromu\n");
          return 1;
        }
      }
    }
  }
}
void Tisk(struct uzel * p)
{
  /* printf("%4d %4d %4d\n",p->klic,p->pocet,p->level); */
  if (p->levy!=NULL)
  Tisk(p->levy);
  /* printf("%4d %4d %4d\n",p->klic,p->pocet,p->level); */
  if (p->pravy!=NULL)
  Tisk(p->pravy);
  printf("%4d %4d %4d\n",p->klic,p->pocet,p->level);
}
int Tisk2(struct uzel *p)
{
  struct uzel *q;
  struct uzel *fronta[100];
  int zacat=0,kon=0,poc=0;
  if (poc<100)
  {
    fronta[kon]=p; poc++;       /* koren stromu ukladam do fronty */
    
    if(kon<99) kon++;
    else kon=0;
  }
  while(poc>0)                  /* dokud fronta neni prazdna */
  {
    q=fronta[zacat]; poc--;     /* odeberu z fronty */
    if (zacat<99) zacat++;
    else zacat=0;
    printf("%4d %4d %4d\n",q->klic,q->pocet,q->level);   /* zobrazim */
    if (q->levy!=NULL)          /* a ulozim do fronty ukazatel vlevo */    
    {                           /* pokud neni NULL                   */
      if (poc<100)
      {
        fronta[kon]=q->levy; poc++;
        if(kon<99) kon++;
        else kon=0;
      }
    }
    if (q->pravy!=NULL)         /* ulozim do fraonty ukazatel vpravo */
    {                           /* pokud neni NULL                   */
      if (poc<100)
      {
        fronta[kon]=q->pravy; poc++;
        if(kon<99) kon++;
        else kon=0;
      }	
    }
  }
}
void Zrus(struct uzel *p)
{
  if (p->levy != NULL)
  Zrus(p->levy);
  if (p->pravy != NULL)
    Zrus(p->pravy);
  free (p);
}
int main()
{
  p=NULL;
  int i;
  int pole[11] = {5,11,2,2,4,9,1,12,8,3,10};
  for (i=0; i<11; i++)
  {
    x = pole[i];
    if (BinTree(x) == 1)
    {
      printf("Nedostatek pameti\n");
      return 1;
    }
  }
  /*
  srand((unsigned int)time(NULL));
  for(i=1;i<KOLIK;i++)
  {
    x=rand()%KOLIK +1;
    if (BinTree(x) == 1)
    {
      printf("Neni pamet\n");
      return 1;
    }
  }
  */
  printf("Pruchod stromem do hloubky:\n");
  printf("klic pocet uroven\n");
  Tisk(p);
  printf("Pruchod stromem do sirky:\n");
  printf("klic pocet uroven\n");
  Tisk2(p);
  printf("Zadejte hodnotu, ktera se ma ze stromu vynechat:");
  scanf("%d",&x);
  if (x!=0)
  {
    if (Vynech(x) == 0)
    Tisk(p);
    getch();
  } 
  Zrus(p);
  return 0;
}
