/* KunJde.c */
/* K m projt vemi poli achovnice NxN, ani by nkter pole    */
/* navtvil dvakrt. Pouzita metoda: backtracking - prohledavani   */
/* s navratem, realizovane rekurzivni procedurou. Poradi zkousenych */
/* tahu kone rizeno heuristikou: nejprve se jde na pole s mensim    */
/* poctem moznosti dalsiho pokracovani cesty                        */
#include <stdio.h>
#include <conio.h>
#define N 5
#define NKV (N*N)
#define TAHU 8
int s[N][N];                         /* sachovnice          */
int a[TAHU]={1,2,2,1,-1,-2,-2,-1};
int b[TAHU]={2,1,-1,-2,-2,-1,1,2};
int start1,start2;                   /* vychozi pozice kone */
int i,j;
int nalez;
int Sm[TAHU];

int PocVoln(int i1, int i2)
{
int smer;
int j1,j2;
int pocet;
pocet=0;
/* printf("i1=%d i2=%d\n",i1,i2); */
for(smer=0;smer<TAHU;smer++)
	{
	j1=i1+a[smer]; j2=i2+b[smer];
	/* printf("ted j1=%d j2=%d smer=%d\n",j1,j2,smer); */ 
	if ((j1>=0) && (j1<N) && (j2>=0) && (j2<N))
		{
			if (s[j1][j2]==-1)
			{
				/* printf("j1=%d j2=%d smer=%d\n",j1,j2,smer); */
				pocet=pocet+1;
			}
			
		}
	}
/* printf("pocet=%d\n",pocet); */
return pocet;
}

int UrciSmery(int i1,int i2,int Sm[])
{
	/* pomocna procedura pro nalezeni vsech moznych tahu kone */
	/* z pozice (i1,i2). smery tahu ulozi do pole Sm, jejich  */
	/* pocet do PocSm.Tahy seradi podle heuristiky            */
	int k,x;
	int j1,j2;
	int smer;
	int PocSm;
	int Volne[TAHU]; /* pocet volnych poli v okoli pole podle Sm  */
	PocSm=0;
	/* printf("V UrciSmery je i1=%d,i2=%d\n",i1,i2); */
	for (smer=0;smer<TAHU;smer++)
	{
		j1=i1+a[smer]; j2=i2+b[smer];
		if ((j1>=0) && (j1<N) && (j2>=0) && (j2<N))
        /* je uvnitr sachovnice */
		{
		if (s[j1][j2]==-1)
			{
				Sm[PocSm]=smer; /* printf("smer=%d\n",smer); */
				Volne[PocSm]=PocVoln(j1,j2); PocSm=PocSm+1;
			}
		}
	}
	 
	/* pole Sm je naplneno pripustnymi tahy,jeste urcime poradi */
	/* podle poctu volnych sousednich poli                      */
	for(i=0;i<PocSm;i++)
	{
		k=i;
		for(j=i+1;j<PocSm;j++)
		{
			if(Volne[j]<Volne[k])
			{
				k=j;
				if(k>i)
				{
					x=Sm[k];Sm[k]=Sm[i];Sm[i]=x;
					x=Volne[k];Volne[k]=Volne[i];Volne[i]=x;
				}
			}
		}
	}
/*	for(i=0;i<PocSm;i++)
	{
		printf("i=%d ",i);
		printf("Sm[i]= %d volne[i]=%d\n",Sm[i],Volne[i]);
	}
	printf("\n"); */
	return(PocSm);
}

int cesta(int i1,int i2)
/* procedura pro nalezeni cesty kone z pozice (i1,i2) do konce.  */
/* Zacatek cesty je ulozen v globalnim poli s. Vystupni parametr */
/* nalez udava, zda se cestu podarilo nalezt.                    */
{
	int krok;					 /* poradove cislo tahu */
	int smer;
	int j1,j2;
	int PocSm;
	/*if (nalez==1) return nalez ; */
	/* printf("i1=%d i2=%d\n",i1,i2); */ 
	krok = s[i1][i2] + 1; smer = 0;
	PocSm=UrciSmery(i1,i2,Sm);
	/* printf("PocSm=%d, Sm[0]=%d, Sm[1]=%d\n",PocSm,Sm[0],Sm[1]); */ 
	nalez = 0;                    /* nenalezeno         */
	while((smer < PocSm) && (nalez == 0))
	{
		j1=i1+a[Sm[smer]]; j2=i2+b[Sm[smer]];
		if ((j1>=0) && (j1<N) && (j2>=0) && (j2<N))  
        /* je uvnitr sachovnice */
		{
			if (s[j1][j2]==-1)
			{
				s[j1][j2]=krok;
				/* printf("j1=%d,j2=%d,krok=%d\n",j1,j2,krok); 
                getch(); */     
				if(krok==(NKV - 1))     
				{
					nalez=1;              /* nalezeno reseni    */    
					return nalez;
				}
				else
				{
					if  (cesta(j1,j2)==0)
					{
						s[j1][j2]=-1;     /* neuspesny pokus    */      
					}
				}
			}
		} 
		smer=smer+1;              /* novy zkouseny smer */
	}
	return nalez;
}

int main()
{ 
	for(i=0;i<N;i++)
	{
		for(j=0;j<N;j++)
			s[i][j]=-1; 
	}
	nalez=0;
	printf("Zadejte pocatecni pozici kone\n");
	scanf("%d%d",&start1,&start2);
	s[start1][start2]=0;
	if(cesta(start1,start2)==1)
	{
		for(i=0;i<N;i++)
		{
			for(j=0;j<N;j++)
			{
				printf("%3d",s[i][j]);
			}
			printf("\n");
		}     
	}
	else
		printf("Cesta neexistuje\n");
	system("PAUSE");	
    return 0;		
}
