/* sudoku.c */
/* Kazdy sloupec, radek i ctverec o 3x3 polich musi */
/* obsahovat vsechny  cislice od 1 do 9             */
/* Program cte vstup ze souboru sudok1.dta, potom   */
/* zobrazi vstupni i vyslednou matici 9x9.          */
/* Pak zadejte nulu.                                */

#include <stdio.h>
FILE *fr;
short m[9][9];
short i,j,k,dost,n;
short e,f;              /* hodnoty urcuji zpusob prace funkce oznac */ 
short r[81];            /* zaznamy doplnenych cisel pro bactracking */
short s[81];            /* do pole r se zaznamenava i, do s j       */
short t[81];            /* do pole t se zaznamena k                 */
short p[9][9][9];       /* p[i,j,k] nenulove znamena, ze hodnota k  */ 
                        /* je nepripustna pro policko m[i,j]        */  
char *jmeno="sudok1.txt";
	
int oznac(short u, short v, short x)
{
  short i,j;  
  /* radek */
  for (i=0;i<9;i++)
    if (p[u][i][x]==e) p[u][i][x]=f;
  /* sloupec */
  for (i=0;i<9;i++)
    if (p[i][v][x]==e) p[i][v][x]=f; 
  /* ctverecek 3x3 */
  if (u<3) u=0;
  else if (u<6) u=3; else u=6;
  if (v<3) v=0;
  else if (v<6) v=3; else v=6;
  for (i=u;i<u+3;i++)
    for (j=v;j<v+3;j++)
      if (p[i][j][x]==e) p[i][j][x]=f;
  return 0;
}

int main()
{
  /* cteni zadani */
  if ((fr=fopen(jmeno,"rt"))==NULL)
    {
      printf("Soubor nemohu otevrit\n"); 
      system("PAUSE");
      return 1;
    }
  for(i=0;i<9;i++)
    for(j=0;j<9;j++)
      fscanf(fr,"%d",&m[i][j]);
  /* Vstupni zadani */
  printf("\nZadani\n");
  for(i=0;i<9;i++)
  {
    for(j=0;j<9;j++)
      printf("%d",m[i][j]);
    printf("\n");
  } 
  /* hodnoty do pole p */
  e=0; f=1;
  for(i=0;i<9;i++)
    for(j=0;j<9;j++)
      if (m[i][j]>0) oznac(i,j,m[i][j]);
  /* v cyklu hledam policka k doplnovani */
  n=0; k=1;
  i=0; j=0;
  while(i<9)
  {
    if (m[i][j]==0)
    {
      dost=0;
      while ((k<10) && (dost==0))
      {
        if (p[i][j][k]==0)
        {
          m[i][j]=k; e=0; dost=1;
          r[n]=i; s[n]=j; t[n]=k; n++; f=n+1; oznac(i,j,k);  
        }
        else k++;
      }  
      if (dost==0) /* navrat zpet */
      {
         do
         {
            n--;
            if(n<0) 
            { 
              printf("Neexistuje reseni\n");
               system("PAUSE");       
              return 1;
            }
            else
            {  
              i=r[n]; j=s[n]; k=t[n]; e=n+2; f=0; 
              oznac(i,j,k); m[i][j]=0; k++;
            }
         }
         while (k>=10);
         continue;  
      }
    }
    k=1; j++; if(j>=9) {i++;j=0;}
  }
  printf("\nVysledek\n");
  for(i=0;i<9;i++)
  {
    for(j=0;j<9;j++)
      printf("%d",m[i][j]);
    printf("\n");
  }
  system("PAUSE");    
  return 0;
}



  
  
