
#include <stdio.h>
#include <conio.h>
#define UZLU 1000
#define MAX 100000000
/* Definice */
int uzlu;                 /* pocet uzlu */
int hran;                 /* pocet hran */
int kapacita[UZLU][UZLU]; /* matice kapacit */
int tok[UZLU][UZLU];      /* matice toku */
int oznac[UZLU];          /* pro prohledavani do sirky */              
int cesta[UZLU];          /* pole pro zlepsujici cestu */

int min (int x, int y) 
{
    return x<y ? x : y;  
}
/* fronta pro hledani do sirky */
int zac,kon;
int f[UZLU+2];

void vloz (int x) 
{
    f[kon] = x;
    kon++;
    oznac[x] = 0;
}

int vezmi () 
{
    int x = f[zac];
    zac++;
    oznac[x] = 1;
    return x;
}
/* hledani zlepsujici cesty */
int hle (int start, int cil) 
{
    int u,v,i;
    for (u=0; u<uzlu; u++) 
	oznac[u] = -1;   
    zac = kon = 0;
    vloz(start);
    cesta[start] = -1;
    while (zac!=kon) 
    {
	  u = vezmi();
        /* hleda uzly v oznacene -1 . Je-li rozdil
        kapacita - tok z u do v kladny, vlozime v */
	  for (v=0; v<uzlu; v++) 
	    if (oznac[v]==-1 && kapacita[u][v]-tok[u][v]>0) 
        {                 
		  vloz(v);
		  cesta[v] = u; /* printf("u=%d v=%d ",u,v); */
	    }
    }
    return oznac[cil]==1;
}
/* Ford-Fulkersonuv algoritmus */
int max_tok (int zdroj, int stok)
{
    int i,j,u,k,s;
    /* Inicializace prazdneho toku */
    int max_tok = 0;
    for (i=0; i<uzlu; i++) 
	for (j=0; j<uzlu; j++)
	    tok[i][j] = 0;
    /* Dokud existuje zlepsujici cesta,
       zvysit tok podel teto cesty. */
    while (hle(zdroj,stok)) 
    {
    /* urci hodnotu, o niz muzeme zvysit tok. */
	int prirustek = MAX;
	for (u=uzlu-1; cesta[u]>=0; u=cesta[u])
	    prirustek = min(prirustek,kapacita[cesta[u]][u]-tok[cesta[u]][u]);
    /* Nyni zvysit tok */
	for (u=uzlu-1; cesta[u]>=0; u=cesta[u])
    {
	    tok[cesta[u]][u] += prirustek;
	    tok[u][cesta[u]] -= prirustek;
	}
	printf("prirustek=%d\n ",prirustek);
	printf("Matice toku\n");
	for (k=0;k<uzlu;k++)
	{
        for (s=0;s<uzlu;s++) 
            printf("%3d ",tok[k][s]);
        printf("\n");
    } 
	max_tok += prirustek;
    }
    /* zlepsujici cesta uz neni */
    return max_tok;
}
/* cteni vstupniho souboru */
void read_input_file() 
{
    int a,b,c,i,j;
    FILE * input;
    if ((input = fopen("mf1.txt","rt"))==NULL)
      printf("nemohu otevrit\n");
    /* cte pocet uzlu a hran */
    fscanf(input,"%d %d",&uzlu,&hran);
    printf("uzlu=%d hran=%d\n",uzlu,hran);
    /* vynulovani matice kapacit */ 
    for (i=0; i<uzlu; i++) 
    {
	  for (j=0; j<uzlu; j++) 
	    kapacita[i][j] = 0;
    }
    /* cte kapacity hran */
    for (i=0; i<hran; i++) 
    {
	  fscanf(input,"%d %d %d",&a,&b,&c);
	  kapacita[a][b] = c;
    }
    fclose(input);
}

int main () 
{
    int k,s;
    read_input_file();
    printf("Matice kapacit\n");
	for (k=0;k<uzlu;k++)
	{
        for (s=0;s<uzlu;s++) 
            printf("%3d ",kapacita[k][s]);
        printf("\n");
    } 
    printf("Maximalni tok=%d\n",max_tok(0,uzlu-1));
    system("PAUSE");
    return 0;
}

    
    
    
    

