
#include <stdio.h> 
#include <stdlib.h>
#define UZLU 200
#define HRAN 500

    int poradi[UZLU];   /* poradi navstiveni uzlu */
    int koren[UZLU];    /* nejnizsi cislo */
    int zasobnik[UZLU]; /* zasobnik */
    int p;	            /* posice v zasobniku   */
    int vzas[UZLU];     /* je v zasobniku? */
	int v[HRAN];        /* vstupni uzel hrany   */
	int w[HRAN];        /* vystupni uzel hrany  */ 
	int u[UZLU+1];      /* v poli indexuji od 0 */
	int e[HRAN];        /* indexuji od 0 */
	int aktualni;
	/* u a e tvori seznam nasledniku, v a w seznam hran */

void tarjan(int v) 
{
    int i,j;
    poradi[v]=aktualni;    /* ocislovani vrcholu */
    koren[v]=aktualni;     /* inicializace nejnizsiho dosazeneho */
    aktualni++;
    zasobnik[p++]=v;       /* pridej do zasobniku */
    vzas[v]=1;             /* poznac oridani */
    int w; 
    for(j=u[v];j<u[v+1];j++) /* smycka pro vsechny nasledniky */
    { 
        w=e[j]; /* naslednik */
        if (poradi[w] == -1)
        { /* uzel nenavstiven */ 
            tarjan(w);
            koren[v]=(koren[v]<koren[w])? koren[v]:koren[w];
        }
        else if (vzas[w]) koren[v]=(koren[v]<poradi[w])? koren[v]:poradi[w];
    }
    if (koren[v] == poradi[v]) 
        { /* nalezena SSK */
        do 
        { /* odebirej vrcholy ze zasobniku */
             if (p > 0)
             {
                 w=zasobnik[--p];
                 printf("%d ",w);
                 vzas[w]=0;
             }
        } while (w != v && p > 0);
        printf("\n");
    }
}

int main(void) 
{
    int i,j,k,x,y;
    /* nacti vstup */
   	int uzlu,hran; /* skutecny pocet uzlu a hran */
	printf ("Zadejte pocet uzlu:\n");
	scanf ("%d",&uzlu);
	printf ("Zadejte pocet hran:\n");
	scanf ("%d",&hran);
	printf("Zadejte vstupni a vyst.uzel jednotlivych hran:\n");
	for (j=0;j<hran;j++)
    {
		scanf("%d%d",&v[j],&w[j]);
    }    
    /* setrideni seznamu hran podle vst.uzlu */
    for (i=0; i<hran; i++)
	{
		k=i; x=v[i]; y=w[i];
		for (j=i+1; j<hran; j++)
			if (v[j]<x)
			{
				k=j; x =v[j]; y=w[j];
			}
			v[k]=v[i]; v[i]=x; w[k]=w[i]; w[i]=y; 
	}                          						                         
	/* algoritmus pro seznam nasledniku */
	k=0; i=0; /* k je cislo uzlu, i index v e */
	for (j=0;j<uzlu+1;j++) u[j]=0;
	for (j=0;j<hran;j++)
	{
		if (v[j]==k)
		{
            e[i]=w[j]; i++;
        }
        else
        {
            k=v[j]; u[k]=i; 
            e[i]=w[j]; i++;
        }
	}
	for (j=k+1;j<uzlu+2;j++)
	u[j]=i; 
	for (j=1;j<uzlu+2;j++)
	   if (u[j]==0) u[j]=u[j+1]; 
    for(i=0;i<uzlu;i++)
        { koren[i] = poradi[i] = -1; } /* inicializace */
    printf("seznam nasledniku:\n");
    printf("u: ");
    for (i = 0; i < uzlu+1; i++) printf("%d ",u[i]);
    printf("\n");
    printf("e: ");
    for (i = 0; i < hran; i++) printf("%d ",e[i]);
    printf("\nseznam silne souvislych komponent:\n");
    aktualni=0; p=0;               /* init; zasobnik je prazdny */
    for (i=0;i<uzlu;i++)
        if (poradi[i] == -1)       /* nalezen neocislovany vrchol    */
            tarjan(i);             /* spusti prohledavani do hloubky */
    system ("PAUSE");
    return 0;
}
